\documentclass[a4paper,10pt]{article}

\begin{document}

\title{\textbf{CPU modes}}
\author{Pawel Dziepak}
\date{\textit{June 01, 2008}}
\maketitle

\section{Introduction}
\paragraph{}x86 processors can work in different modes of operation which provides specific
features and possibilities that allow operating system to manage the computer.
In currently produced CPUs there are five modes of operation available.
\begin{itemize}
\item{real mode}
\item{protected mode}
\item{virtual-8086 mode}
\item{system management mode}
\item{IA-32e mode}
\end{itemize}
\paragraph{}The last listed mode has two sub-modes:
\begin{itemize}
\item{compatibility mode}
\item{64-bit mode}
\end{itemize}


\section{Real mode}
\paragraph{}This mode is preserved in modern CPUs only for compatibility reasons. When CPU
starts it works in this mode. The environment is very similar to the 8086 one,
except some additional extensions. It means that there is no memory protection,
paging and task switch segments. Memory is addressed using segments and offset.

\paragraph{}Interrupts are configured by interrupt vectors table which is placed at the
beginning of available memory (0x0000:0x0000). It is a table of two words that
saves address of the interrupt handler (first word for segment, second for
offset).

\section{Protected mode}
\paragraph{}It is the native state of the CPU. Memory protectiong can be created using
either segmentation or paging. Segmentation is configured by GDT (global
descriptors table) and LDTs (local descriptors table). The consist of
information about base and limit of segment, its type and access information.
Paging is configured using page directories and page tables (optional). Each
page represent a 4kB (or 4MB) of memory. There is possibilty to set access
information. Multitasking can be achieved using task switch segments, which
are descriptors of special type in GDT that saves execution context. Interrupts
are configured using IDT (interrupt descriptor tables) which consist of
information about handler address, access restrictions and their type.

\subsection{Switching to protected mode}

\paragraph{}Switching to protected mode from real mode is done by system loader. First
important action is disabling interrupts (all, including NMI). Then correct
GDT has to be loaded. Next operation is setting PE flag (bit 0) in CR0 register.
After that CPU works in protected mode, and far jump to correct memory address
have to be performed. If operating system uses LDT it should be loaded. Then
TR register should be given a correct TSS descriptor. Next step is to load new,
protected-mode-style values to the segments registers (old ones are correct
until this operation). Finally loader has to set IDT and enable interrupts. Then
protected mode is fully initialized. After that there is possibility to enable
paging. All data structures used while initializing protected mode should be
created in real mode.

\end{document}
